// AboutDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PvSimpleUISample.h"
#include "AboutDlg.h"

#include <PvDeviceFinderWnd.h>
#include <PvDevice.h>
#include <PvGenParameter.h>
#include <PvGenBrowserWnd.h>
#include <PvBuffer.h>
#include <PvStream.h>
#include <PvPipeline.h>
#include <PvDisplayWnd.h>
#include <PvSystem.h>
#include <PvVersion.h>

class CVersionInfo
{
private:
	long	m_versionMajor;
	long	m_versionMinor;
	long	m_versionOther;
	long	m_versionBuild;

	long	m_productVersionMajor;
	long	m_productVersionMinor;
	long	m_productVersionOther;
	long	m_productVersionBuild;

	long	m_appVersionMajor;
	long	m_appVersionMinor;
	long	m_appVersionOther;
	long	m_appVersionBuild;

    CString m_ProdName;
    CString m_LegalCopyright;
    CString m_CompanyName;

public:
    // Constructors
    CVersionInfo();
	
    void GetMyVersionInfo();

	DWORD GetMajorVersion(){return m_versionMajor;}
	DWORD GetMinorVersion(){return m_versionMinor;}
	DWORD GetOtherVersion(){return m_versionOther;}
	DWORD GetBuildVersion(){return m_versionBuild;}

	DWORD GetProductMajorVersion(){return m_productVersionMajor;}
	DWORD GetProductMinorVersion(){return m_productVersionMinor;}
	DWORD GetProductOtherVersion(){return m_productVersionOther;}
	DWORD GetProductBuildVersion(){return m_productVersionBuild;}

	DWORD GetAppMajorVersion(){return m_appVersionMajor;}
	DWORD GetAppMinorVersion(){return m_appVersionMinor;}
	DWORD GetAppOtherVersion(){return m_appVersionOther;}
	DWORD GetAppBuildVersion(){return m_appVersionBuild;}

    CString GetProductName() {return m_ProdName;}
	CString GetLegalCopyright() {return m_LegalCopyright;}
	CString GetCompanyName() {return m_CompanyName;}
};

CVersionInfo::CVersionInfo()
{
    m_versionMajor = 0L;
    m_versionMinor = 0L;
    m_versionOther = 0L;
    m_versionBuild = 0L;

	m_productVersionMajor =	0;
	m_productVersionMinor =	0;
	m_productVersionOther =	0;
	m_productVersionBuild =	0;

    m_ProdName = _T("");
    m_LegalCopyright = _T("Copyright  1997-2001");
    m_CompanyName = _T("FLIR Systems AB");

    CString modName;
    modName = _T("C:\\Windows\\System32\\drivers\\ebUniversalProForEthernet.sys");

    DWORD dwVerHnd = 0;			         // An 'ignored' parameter, always '0'
    DWORD dwVerInfoSize = GetFileVersionInfoSize (modName, &dwVerHnd);
    if (dwVerInfoSize == 0) {
        // Try another older name of the eBUS driver
        dwVerHnd = 0;
        modName = _T("C:\\Windows\\System32\\drivers\\EbUniversalPro.sys");
        dwVerInfoSize = GetFileVersionInfoSize (modName, &dwVerHnd);

        if (dwVerInfoSize == 0) {
            dwVerHnd = 0;
            modName = _T("C:\\Windows\\System32\\drivers\\EbBusDriver.sys");
            dwVerInfoSize = GetFileVersionInfoSize (modName, &dwVerHnd);
        }
    }

    if (dwVerInfoSize == 0)
        return;
  
	wchar_t	*versionInfo = new wchar_t [dwVerInfoSize];
	if (GetFileVersionInfo(modName, 0, dwVerInfoSize, versionInfo) == 0)
    {
        delete [] versionInfo;
        return;
    }

	VS_FIXEDFILEINFO *fixedInfo;
	unsigned int valueLen;
	if (VerQueryValue( versionInfo, _T("\\"), (void **) &fixedInfo, &valueLen ) == 0)
    {
        delete [] versionInfo;
        return;
    }

    m_versionMajor = HIWORD( fixedInfo->dwFileVersionMS );
	m_versionMinor = LOWORD( fixedInfo->dwFileVersionMS );
	m_versionOther = HIWORD( fixedInfo->dwFileVersionLS );
	m_versionBuild = LOWORD( fixedInfo->dwFileVersionLS );
	m_productVersionMajor =	HIWORD( fixedInfo->dwProductVersionMS);
	m_productVersionMinor =	LOWORD( fixedInfo->dwProductVersionMS );
	m_productVersionOther =	HIWORD( fixedInfo->dwProductVersionLS );
	m_productVersionBuild =	LOWORD( fixedInfo->dwProductVersionLS );

    UINT    uVersionLen;
    wchar_t fileParam[256];
    LPVOID version=NULL;
    DWORD langD;

    swprintf_s(fileParam, 256, _T("\\VarFileInfo\\Translation"));
    if (VerQueryValue ( versionInfo,  fileParam, &version, (UINT *)&uVersionLen) == 0)
    {
        delete [] versionInfo;
        return;
    }

    memcpy(&langD, version, 4);
    swprintf_s(fileParam, 256, _T("\\StringFileInfo\\%02X%02X%02X%02X\\ProductName"),
        (langD & 0xff00)>>8,langD & 0xff,(langD & 0xff000000)>>24, 
        (langD & 0xff0000)>>16);			

    wchar_t* lpwStr;	// String pointer
    VerQueryValue(versionInfo, fileParam, (LPVOID *)&lpwStr, (UINT *)&uVersionLen);
    m_ProdName = CString(lpwStr);

    swprintf_s(fileParam, 256, _T("\\StringFileInfo\\%02X%02X%02X%02X\\LegalCopyright"),
        (langD & 0xff00)>>8,langD & 0xff,(langD & 0xff000000)>>24, 
        (langD & 0xff0000)>>16);
    VerQueryValue(versionInfo, fileParam, (LPVOID *)&lpwStr, (UINT *)&uVersionLen);
    m_LegalCopyright = CString(lpwStr);;

    swprintf_s(fileParam, 256, _T("\\StringFileInfo\\%02X%02X%02X%02X\\CompanyName"),
        (langD & 0xff00)>>8,langD & 0xff,(langD & 0xff000000)>>24, 
        (langD & 0xff0000)>>16);
    VerQueryValue(versionInfo, fileParam, (LPVOID *)&lpwStr, (UINT *)&uVersionLen);
    m_CompanyName = CString(lpwStr);;

    delete [] versionInfo;
}

void CVersionInfo::GetMyVersionInfo()
{
    CString modName = AfxGetAppName();
    modName = modName + _T(".exe");

    DWORD dwVerHnd = 0;			         // An 'ignored' parameter, always '0'
    DWORD dwVerInfoSize = GetFileVersionInfoSize (modName, &dwVerHnd);
    if (dwVerInfoSize == 0)
        return;
	wchar_t	*versionInfo = new wchar_t [dwVerInfoSize];
	if (GetFileVersionInfo(modName, 0, dwVerInfoSize, versionInfo) == 0)
    {
        delete [] versionInfo;
        return;
    }

	VS_FIXEDFILEINFO *fixedInfo;
	unsigned int valueLen;
	if (VerQueryValue( versionInfo, _T("\\"), (void **) &fixedInfo, &valueLen ) == 0)
    {
        delete [] versionInfo;
        return;
    }

	m_appVersionMajor =	HIWORD( fixedInfo->dwFileVersionMS);
	m_appVersionMinor =	LOWORD( fixedInfo->dwFileVersionMS );
	m_appVersionOther =	HIWORD( fixedInfo->dwFileVersionLS );
	m_appVersionBuild =	LOWORD( fixedInfo->dwFileVersionLS );

    delete [] versionInfo;
}
// AboutDlg dialog

IMPLEMENT_DYNAMIC(AboutDlg, CDialog)

AboutDlg::AboutDlg(CWnd* pParent /*=NULL*/)
	: CDialog(AboutDlg::IDD, pParent)
    , m_DrvInfo(_T(""))
    , m_SDKVersion(_T(""))
    , m_AppVersion(_T(""))
{

}

AboutDlg::~AboutDlg()
{
}

void AboutDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_DRV_INFO, m_ctrlDrvInfo);
    DDX_Text(pDX, IDC_DRV_INFO, m_DrvInfo);
    DDX_Control(pDX, IDC_SDK_VERSION, m_ctrlSDKVer);
    DDX_Text(pDX, IDC_SDK_VERSION, m_SDKVersion);
    DDX_Text(pDX, IDC_APP_VERSION, m_AppVersion);
}


BEGIN_MESSAGE_MAP(AboutDlg, CDialog)
END_MESSAGE_MAP()


// AboutDlg message handlers
BOOL AboutDlg::OnInitDialog()
{
    CVersionInfo info;
    PvResult lResult;
    PvSystem lSystem;

    info.GetMyVersionInfo();
    m_AppVersion.Format(_T("App version %d.%d.%d.%d"),                 
        info.GetAppMajorVersion(),
        info.GetAppMinorVersion(),
        info.GetAppOtherVersion(),
        info.GetAppBuildVersion());

    // Display eBUS SDK version used
    m_SDKVersion.Format(_T("The application has been built using Pleora eBUS SDK ver %S"), NVERSION_STRING);

    // Display information about all found interfaces
	lResult = lSystem.Find();
	if ( !lResult.IsOK() )
		return FALSE;

    m_DrvInfo.Empty();
    // For each interface, display information about driver status
    for( uint32_t x = 0; x < lSystem.GetInterfaceCount(); x++ )
    {
         // Find default source address
         const PvNetworkAdapter *lNetworkAdapter = dynamic_cast<const PvNetworkAdapter *>( lSystem.GetInterface( x ) );
         if ( lNetworkAdapter )
         {
            // get pointer to each of interfaces

            TRACE( "Interface %i\nMAC Address: %s\nIP Address: %s\nSubnet Mask: %s",
                x,
                lNetworkAdapter->GetMACAddress().GetAscii(),
                lNetworkAdapter->GetIPAddress().GetAscii(),
                lNetworkAdapter->GetSubnetMask().GetAscii() );

            if ( lNetworkAdapter->IsPleoraDriverInstalled())
            {
        	        CString ip, intf;
        	        ip = lNetworkAdapter->GetIPAddress().GetUnicode();

                    intf.Format(_T("eBUS driver %d.%d.%d.%d activated on interface %s\n"),
                        info.GetMajorVersion(),
                        info.GetMinorVersion(),
                        info.GetOtherVersion(),
                        info.GetBuildVersion(),
                        ip);
                    m_DrvInfo += intf;
             }
             else {
       	        CString ip, intf;
       	        ip = lNetworkAdapter->GetIPAddress().GetUnicode();
                intf.Format(_T("eBUS driver not found on interface %s\n"), ip);
                m_DrvInfo += intf;
             }
         }
    }

    UpdateData(FALSE);
    return TRUE;  // return TRUE  unless you set the focus to a control
}
