// AlarmSetupDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PvSimpleUISample.h"
#include "AlarmSetupDlg.h"


// CAlarmSetupDlg dialog

IMPLEMENT_DYNAMIC(CAlarmSetupDlg, CDialog)

CAlarmSetupDlg::CAlarmSetupDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAlarmSetupDlg::IDD, pParent)
	, m_dwPulseTime(0)
	, m_AlarmValue(0)
	, m_bFlash(FALSE)
{
	m_iCondition = ALARM_COND_ABOVE; // Default
	m_dwPulseTime = 2000;
	m_DigOut = 0;
}

CAlarmSetupDlg::~CAlarmSetupDlg()
{
}

void CAlarmSetupDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_MEAS_FUNC, m_ctrlFunc);
	DDX_Control(pDX, IDC_RESULT, m_ctrlResult);
	DDX_Control(pDX, IDC_CONDITION, m_ctrlCondition);
	DDX_Control(pDX, IDC_DIGOUT, m_ctrlDigOut);
	DDX_Control(pDX, IDC_ACTIVE, m_ctrlActive);
	DDX_Text(pDX, IDC_PULSE_TIME, m_dwPulseTime);
	DDX_Text(pDX, IDC_EDIT1, m_AlarmValue);
	DDX_Control(pDX, IDC_FLASH, m_ctrlFlash);
	DDX_Check(pDX, IDC_FLASH, m_bFlash);
}



BEGIN_MESSAGE_MAP(CAlarmSetupDlg, CDialog)
	ON_BN_CLICKED(IDC_FLASH, &CAlarmSetupDlg::OnBnClickedFlash)
	ON_BN_CLICKED(IDC_ACTIVE, &CAlarmSetupDlg::OnBnClickedActive)
	ON_CBN_SELCHANGE(IDC_CONDITION, &CAlarmSetupDlg::OnCbnSelchangeCondition)
	ON_BN_CLICKED(IDOK, &CAlarmSetupDlg::OnBnClickedOk)
	ON_CBN_SELCHANGE(IDC_DIGOUT, &CAlarmSetupDlg::OnCbnSelchangeDigout)
	ON_CBN_SELCHANGE(IDC_MEAS_FUNC, &CAlarmSetupDlg::OnCbnSelchangeMeasFunc)
	ON_CBN_SELCHANGE(IDC_RESULT, &CAlarmSetupDlg::OnCbnSelchangeResult)
END_MESSAGE_MAP()


// CAlarmSetupDlg message handlers

// =============================================================================
BOOL CAlarmSetupDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_ctrlFunc.SetCurSel(m_AlarmFunc);

	m_ctrlResult.ResetContent();
	if (m_AlarmFunc == ALARM_FUNC_AREA)
	{
		m_ctrlResult.AddString(_T("Avg"));
		m_ctrlResult.AddString(_T("Min"));
		m_ctrlResult.AddString(_T("Max"));
	}
	else
		m_ctrlResult.AddString(_T("Value"));

	m_ctrlResult.SetCurSel(m_AlarmResult);
	m_ctrlCondition.SetCurSel(m_iCondition);

	m_ctrlDigOut.ResetContent();
	m_ctrlDigOut.AddString(_T("None"));
	m_ctrlDigOut.AddString(_T("1"));
    if (m_iDigPorts > 1)
    	m_ctrlDigOut.AddString(_T("2"));

	m_ctrlDigOut.SetCurSel(m_DigOut);

	m_ctrlActive.SetCheck(m_bActive ? BST_CHECKED : BST_UNCHECKED);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAlarmSetupDlg::OnBnClickedFlash()
{
	// TODO: Add your control notification handler code here
}

void CAlarmSetupDlg::OnBnClickedActive()
{
	m_bActive = m_ctrlActive.GetCheck() == BST_CHECKED ? true : false;
}

void CAlarmSetupDlg::OnCbnSelchangeCondition()
{
	m_iCondition = m_ctrlCondition.GetCurSel();
}

void CAlarmSetupDlg::OnBnClickedOk()
{
	UpdateData(TRUE);
	OnOK();
}

void CAlarmSetupDlg::OnCbnSelchangeDigout()
{
	m_DigOut = m_ctrlDigOut.GetCurSel();
}

void CAlarmSetupDlg::OnCbnSelchangeMeasFunc()
{
	m_AlarmFunc = m_ctrlFunc.GetCurSel();

	m_ctrlResult.ResetContent();
	if (m_AlarmFunc == ALARM_FUNC_AREA)
	{
		m_ctrlResult.AddString(_T("Avg"));
		m_ctrlResult.AddString(_T("Min"));
		m_ctrlResult.AddString(_T("Max"));
	}
	else 
	{
		m_ctrlResult.AddString(_T("Value"));
		m_AlarmResult = 0;
	}

	m_ctrlResult.SetCurSel(m_AlarmResult);
}

void CAlarmSetupDlg::OnCbnSelchangeResult()
{
	m_AlarmResult = m_ctrlResult.GetCurSel();
}
