// EditObjParsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "PvSimpleUISample.h"
#include "EditObjParsDlg.h"


// CEditObjParsDlg dialog

IMPLEMENT_DYNAMIC(CEditObjParsDlg, CDialog)

CEditObjParsDlg::CEditObjParsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEditObjParsDlg::IDD, pParent)
    , m_AmbTemp(0)
    , m_Emissivity(0)
    , m_ObjectDistance(0)
    , m_RelHum(0)
    , m_AtmTemp(0)
    , m_ExtOptTemp(0)
    , m_ExtOptTransm(0)
{

}

CEditObjParsDlg::~CEditObjParsDlg()
{
}

void CEditObjParsDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    DDX_Control(pDX, IDC_OP_TREFL, m_ctrlReflTemp);
    DDX_Control(pDX, IDC_OP_EMISS, m_ctrlEmissivity);
    DDX_Control(pDX, IDC_OP_DIST, m_ctrlDistance);
    DDX_Control(pDX, IDC_OP_RHUM, m_ctrlRelHum);
    DDX_Control(pDX, IDC_OP_TATM, m_ctrlAtmTemp);
    DDX_Control(pDX, IDC_TEXTOPT, m_ctrlExtOptTemp);
    DDX_Control(pDX, IDC_EDIT7, m_ctrlExtOptTransm);
    DDX_Text(pDX, IDC_OP_TREFL, m_AmbTemp);
    DDV_MinMaxDouble(pDX, m_AmbTemp, -273.15, 5000);
    DDX_Text(pDX, IDC_OP_EMISS, m_Emissivity);
    DDV_MinMaxDouble(pDX, m_Emissivity, 0, 1);
    DDX_Text(pDX, IDC_OP_DIST, m_ObjectDistance);
    DDV_MinMaxDouble(pDX, m_ObjectDistance, 0, 10000);
    DDX_Text(pDX, IDC_OP_RHUM, m_RelHum);
    DDV_MinMaxDouble(pDX, m_RelHum, 0, 100);
    DDX_Text(pDX, IDC_OP_TATM, m_AtmTemp);
    DDV_MinMaxDouble(pDX, m_AtmTemp, -273.15, 5000);
    DDX_Text(pDX, IDC_TEXTOPT, m_ExtOptTemp);
    DDV_MinMaxDouble(pDX, m_ExtOptTemp, -273.15, 5000);
    DDX_Text(pDX, IDC_EDIT7, m_ExtOptTransm);
	DDV_MinMaxDouble(pDX, m_ExtOptTransm, 0, 1);
}


BEGIN_MESSAGE_MAP(CEditObjParsDlg, CDialog)
    ON_BN_CLICKED(IDOK, &CEditObjParsDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CEditObjParsDlg message handlers
// =============================================================================
BOOL CEditObjParsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

    CString s;
    s.Format(_T("%.1f"), m_AmbTemp);
    m_ctrlReflTemp.SetWindowText(s);

    s.Format(_T("%.2f"), m_Emissivity);
    m_ctrlEmissivity.SetWindowText(s);

    s.Format(_T("%.1f"), m_ObjectDistance);
    m_ctrlDistance.SetWindowText(s);

    s.Format(_T("%.0f"), m_RelHum * 100.0f);
    m_ctrlRelHum.SetWindowText(s);

    s.Format(_T("%.1f"), m_AtmTemp);
    m_ctrlAtmTemp.SetWindowText(s);

    s.Format(_T("%.1f"), m_ExtOptTemp);
    m_ctrlExtOptTemp.SetWindowText(s);

    s.Format(_T("%.2f"), m_ExtOptTransm);
    m_ctrlExtOptTransm.SetWindowText(s);

    return TRUE;  // return TRUE  unless you set the focus to a control
}


void CEditObjParsDlg::OnBnClickedOk()
{
    UpdateData(TRUE);

    OnOK();
}
